﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using KLToolBox;
using System.Xml.Serialization;
using System.IO;

namespace KLToolBox
{
    public partial class EditProfForm : Form
    {
        public Form1 MyParentForm;
        public string XMLFullName;
        public FilterProfiles fp;
        public Dirt dirt;
        public EditProfForm()
        {
            InitializeComponent();
        }

        private void AddProfileButton_Click(object sender, EventArgs e)
        {
            // Add new profile 
            string[] BModes = { "Constant", "Variable", "Variable Peak" };
            FilterProfiles.Profile newP;
            int avgOK = 0;
            int peakOK = 0;
            int modeOK = 0;
            int nameOK = 0;
            int commentOK = 0;
            try
            {
                if (int.Parse(ProfAvgBox.Text) >= 200000 && int.Parse(ProfAvgBox.Text) <= 13500000)
                    avgOK = 1;
                if (int.Parse(ProfPeakBox.Text) >= 300000 && int.Parse(ProfAvgBox.Text) <= 20500000)
                    peakOK = 1;
                if (ProfModecomboBox.SelectedIndex >= 0 && ProfModecomboBox.SelectedIndex <= 2)
                    modeOK = 1;
                if (ProfNameBox.Text.Length != 0)
                    nameOK = 1;
                if (ProfCommentBox.Text.Length != 0)
                    commentOK = 1;
            }
            catch { MessageBox.Show("Something is wrong with your values, make sure to fill out all values"); return; }
            if ((avgOK + peakOK + modeOK + nameOK + commentOK) == 5)
                newP = FilterProfiles.CreateProfile(int.Parse(ProfAvgBox.Text), int.Parse(ProfPeakBox.Text), ProfModecomboBox.SelectedIndex);
            else
            {
                MessageBox.Show("Invalid Values were entered in the Form");
                return;
            }
            newP.Name = ProfNameBox.Text;
            newP.Comment = ProfCommentBox.Text;
            fp.Profiles.Add(newP);

            int k = dataGridView1.Rows.Add();
            dataGridView1.Rows[k].Cells[0].Value = newP.Name;
            dataGridView1.Rows[k].Cells[4].Value = newP.Comment;
            dataGridView1.Rows[k].Cells[1].Value = int.Parse(ProfAvgBox.Text);
            dataGridView1.Rows[k].Cells[2].Value = int.Parse(ProfPeakBox.Text);
            dataGridView1.Rows[k].Cells[3].Value = BModes[ProfModecomboBox.SelectedIndex];
            ProfDeletecomboBox.Items.Add(newP.Name);
            
            XmlSerializer ser = new XmlSerializer(fp.GetType());

            using (FileStream stream = File.Open(XMLFullName, FileMode.Create, FileAccess.Write, FileShare.None))
            {
                ser.Serialize(stream, fp);
                stream.Flush();
                stream.Close();
                dirt.dirt = 1;
                return;
            }
        }

        
        private void EditProfForm_Load(object sender, EventArgs e)
        {
            ProfileFileNameTextBox.Text = XMLFullName;
            string[] BModes = { "Constant", "Variable", "Variable Peak" };
            DataTable tbl = new DataTable();
            DataRow row = tbl.NewRow();
            tbl.Columns.Add("Name",typeof(string));
            int k = 0;
            for (int i = 1; i < 4; i++)
                tbl.Columns.Add(new DataColumn("String " + i.ToString(), typeof(int)));
            tbl.Columns.Add("Comment", typeof(string));
            foreach (FilterProfiles.Profile p in fp.Profiles)
            {


                //                row = tbl.NewRow();
                k = dataGridView1.Rows.Add();
                dataGridView1.Rows[k].Cells[0].Value = p.Name;
                dataGridView1.Rows[k].Cells[4].Value = p.Comment;
                ProfDeletecomboBox.Items.Add(p.Name);
                int j = 0;
                foreach (FilterProfiles.Profile.PropSet ps in p.FilterProps)
                {
                    //now apply each filter property
                    j++;
                    if (ps.Comment == "Bitrate Mode")
                    {
                        dataGridView1.Rows[k].Cells[j].Value = BModes[ps.Value];
                    }
                    else
                    {
                        dataGridView1.Rows[k].Cells[j].Value = ps.Value;
                    }

                }
            }
        }

        private void ProfDeleteButton_Click(object sender, EventArgs e)
        {
            foreach (FilterProfiles.Profile p in fp.Profiles)
            {
                if (p.Name == ProfDeletecomboBox.Text)
                {
                    fp.Profiles.Remove(p);
                    ReloadProfDeleteComboBox();
                    dirt.dirt = 1;
                    int rcnt = dataGridView1.Rows.Count;
                    for (int i = 0; i < rcnt; i++)
                    {
                        if (dataGridView1.Rows[i].Cells[0].Value == p.Name)
                        {
                            dataGridView1.Rows.RemoveAt(i);
                            // Save the updated Profile xml file back to disk
                            XmlSerializer ser = new XmlSerializer(fp.GetType());

                            using (FileStream stream = File.Open(XMLFullName, FileMode.Create, FileAccess.Write, FileShare.None))
                            {
                                ser.Serialize(stream, fp);
                                stream.Flush();
                                stream.Close();
                                dirt.dirt = 1;
                                return;
                            }
                            return;
                        }
                    }
                }
            }
        }
        private void ReloadProfDeleteComboBox()
        {
            ProfDeletecomboBox.Items.Clear();
            foreach (FilterProfiles.Profile p in fp.Profiles)
                ProfDeletecomboBox.Items.Add(p.Name);
        }

    }
}
