﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using System.Xml.Serialization;
using System.Diagnostics;
using System.Text.RegularExpressions;
using System.IO;
using DirectShowLib;
using DirectShowLib.Utils;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.ComTypes;

using System.Security.Permissions;

namespace KLToolBox
{
    public partial class Form1 : Form
    {
        public int dirty = 0;
        string rcTVCapLocation;
        public string graphFile;
        string dumpFilterName;
        string capDirectory;
        int capMins = 0;
        int capSecs = 0;
        int capTotalSecs = 0;
        string commandString;
        string recordedFileName;
        Configuration c;
//        Configuration c = new Configuration();
        string DGAVCFile;
        string TSMuxer;
        string CCFile;
        string rcTVCapPath;
        string TemplatePath;
        string x264Path;
        string x264TemplatePath;
        string NodOff;
        string NodOffTime;
        string CCParam;
        bool ProfilesLoaded = false;
        string ConfigXMLFile;
        string KLGraphFile;
        string ProfileText = "";
        FilterProfiles fp = new FilterProfiles();
        public string XMLFullName;
        Dirt dirt = new Dirt();

        #region Newly defined OleCreatePropertyFrame for DirectShowLib usage
        //A (modified) definition of OleCreatePropertyFrame found here: http://groups.google.no/group/microsoft.public.dotnet.languages.csharp/browse_thread/thread/db794e9779144a46/55dbed2bab4cd772?lnk=st&q=[DllImport(%22olepro32.dll%22)]&rnum=1&hl=no#55dbed2bab4cd772
        [DllImport(@"oleaut32.dll")]
        public static extern int OleCreatePropertyFrame(
            IntPtr hwndOwner,
            int x,
            int y,
            [MarshalAs(UnmanagedType.LPWStr)] string lpszCaption,
            int cObjects,
            [MarshalAs(UnmanagedType.Interface, ArraySubType = UnmanagedType.IUnknown)] 
			ref object ppUnk,
            int cPages,
            IntPtr lpPageClsID,
            int lcid,
            int dwReserved,
            IntPtr lpvReserved);
        #endregion

        public Form1()
        {
            InitializeComponent();
            ConfigXMLFile = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath),"config.xml");
            KLGraphFile = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "KLGraph.grf");
            c = Configuration.Deserialize(ConfigXMLFile);
            // Fill in all the textboxes and variables with values read in from the xml config file
            // ************************************************************************************
            // Fill in variables before the Text boxes, to prevent overwriting c.Vars
            graphFile = c.GraphFile;
            capDirectory = c.CaptureLocation;
            dumpFilterName = c.FileDumpFilter;
            rcTVCapLocation = c.rcTVCapLocation;
            c.Version = c.Version;
            DGAVCFile = c.DGAVCDec;
            TSMuxer = c.tsMuxer;
            CCFile = c.ChannelChange;
            TemplatePath = c.TemplatePath;
            x264Path = c.x264Path;
            x264TemplatePath = c.x264Template;
            CCParam = c.CCParam;
            NodOff = c.NodOff;
            NodOffTime = c.NodOffTime;

            // redundant, but too lazy to edit
            textBox1.Text = graphFile = c.GraphFile;
            capTextBox.Text = capDirectory = c.CaptureLocation;
            textBox5.Text = dumpFilterName = c.FileDumpFilter;
            rcTVCaptextBox.Text = rcTVCapLocation = c.rcTVCapLocation;
            c.Version = c.Version;
            textBox10.Text = DGAVCFile = c.DGAVCDec;
            tsMuxBox.Text = TSMuxer = c.tsMuxer;
            CCBox.Text = CCFile = c.ChannelChange;
            templateTextBox.Text = TemplatePath = c.TemplatePath;
            x264TextBox.Text = x264Path = c.x264Path;
            x264TemplateTextBox.Text = x264TemplatePath = c.x264Template;
            CCParamTextBox.Text = CCParam = c.CCParam;
            NodOffTextBox.Text = NodOff = c.NodOff;
            NodOffTimeTextBox.Text = NodOffTime = c.NodOffTime;
            try
            {
                XMLFullName = Path.Combine(Path.GetDirectoryName(rcTVCapLocation), "FilterProfiles.xml");
            }
            catch { }
            if (!File.Exists(XMLFullName))
                {
                ProfileCheckBox.Visible = false ;
                ProfileListBox.Visible = false;
                EditProfButton.Visible = false;
            }
            if (!ProfileCheckBox.Checked)
                EditProfButton.Visible = false;
            //            MessageBox.Show("graphFile="+graphFile+"\r\ncapDirectory="+capDirectory+"\r\nDGAVCFile="+DGAVCFile+"\r\ndumpFilter="+dumpFilterName+
//                "\r\nrcTVCapLocation="+rcTVCapLocation+"\r\n");
            // Read in the First Show in the List
//            comboBox3.SelectionStart = 0;
/*            if (comboBox3.CanFocus)
            {
                comboBox3.Focus();
                comboBox3.Show();
            }
*/
        }

        private string getCommandLine()
        {
            commandString = "rcTVCap " +
                "\"" + graphFile + "\" \"" +
                dumpFilterName + "\" " +
                capTotalSecs.ToString() +
                " \"" + capDirectory + "\\" +
                recordedFileName + ".ts\"";
            if(ProfileCheckBox.Checked && ProfileText.Length != 0)
                commandString += " " + ProfileText;
            c.CaptureLocation = capDirectory;
            c.FileDumpFilter = dumpFilterName;
            c.rcTVCapLocation = rcTVCapLocation;
            c.Version = 2;
            c.GraphFile = graphFile;
            c.DGAVCDec = DGAVCFile;
            c.tsMuxer = TSMuxer;
            c.ChannelChange = CCFile;
            c.TemplatePath = TemplatePath;
            c.x264Path = x264Path;
            c.x264Template = x264TemplatePath;
            c.CCParam = CCParam;
            c.NodOff = NodOff;
            c.NodOffTime = NodOffTime;
            return (commandString);
        }
        #region Buttons
        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog1.InitialDirectory = Path.GetDirectoryName(graphFile);
            }
            catch { } // in case it's first time and notthing has been selected
            openFileDialog1.Filter = "Graph (*.grf)|*.grf";
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            textBox1.Text = graphFile = openFileDialog1.FileName;
            commandLineBox.Text = getCommandLine();
//            textBox10.Text = parseDelay(graphFile);
            // textBox1.Text = graphFile;
            
        }
        private void templateButton_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog1.InitialDirectory = Path.GetDirectoryName(TemplatePath);
            }
            catch { }
            openFileDialog1.Filter = "AVS Files (*.avs)|*.avs|All Files (*.*)|*.*";
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            templateTextBox.Text = TemplatePath = openFileDialog1.FileName;
            commandLineBox.Text = getCommandLine();
//            textBox10.Text = parseDelay(graphFile);
            // textBox1.Text = graphFile;

        }

        private void x264TemplateButton_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog1.InitialDirectory = Path.GetDirectoryName(x264TemplatePath);
            }
            catch { }
            openFileDialog1.Filter = "Mets Files (*.meta)|*.meta|All Files (*.*)|*.*";
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            x264TemplateTextBox.Text = x264TemplatePath = openFileDialog1.FileName;
            commandLineBox.Text = getCommandLine();

        }
        private void x264Button_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog1.InitialDirectory = Path.GetDirectoryName(x264Path);
            }
            catch { }
            openFileDialog1.Filter = "x264 (*.exe)|*.exe|All Files (*.*)|*.*";
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            x264TextBox.Text = x264Path = openFileDialog1.FileName;
            commandLineBox.Text = getCommandLine();
        }

        private void DGButton_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog2.InitialDirectory = Path.GetDirectoryName(DGAVCFile);
            }
            catch { }
            openFileDialog2.Filter = "Index (*.exe)|*.exe";
            if (openFileDialog2.ShowDialog() != DialogResult.OK)
                return;
            textBox10.Text = DGAVCFile = openFileDialog2.FileName;
            commandLineBox.Text = getCommandLine();
            // textBox1.Text = graphFile;

        }
        private void tsMuxerButton_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog3.InitialDirectory = Path.GetDirectoryName(TSMuxer);
            }
            catch { }
            openFileDialog3.Filter = "TsMuxer (*.exe)|*.exe";
            if (openFileDialog3.ShowDialog() != DialogResult.OK)
                return;
            tsMuxBox.Text = TSMuxer = openFileDialog3.FileName;
            commandLineBox.Text = getCommandLine();
            // textBox1.Text = graphFile;

        }
        private void CCButton_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog4.InitialDirectory = Path.GetDirectoryName(CCFile);
            }
            catch { }
            openFileDialog4.Filter = "ChannelChng(*.exe)|*.exe";
            if (openFileDialog4.ShowDialog() != DialogResult.OK)
                return;
            CCBox.Text = CCFile = openFileDialog4.FileName;
            commandLineBox.Text = getCommandLine();
        }
        private void rcTVCapPathButton_Click(object sender, EventArgs e)
        {
            try
            {
                openFileDialog5.InitialDirectory = Path.GetDirectoryName(rcTVCapLocation);
            }
            catch { }
            openFileDialog5.Filter = "rcTVcap(*.exe)|*.exe";
            if (openFileDialog5.ShowDialog() != DialogResult.OK)
                return;
            rcTVCaptextBox.Text = rcTVCapLocation = openFileDialog5.FileName;
            commandLineBox.Text = getCommandLine();

        }

        private void button2_Click(object sender, EventArgs e)
        {
            try
            {
                folderBrowserDialog1.SelectedPath = capDirectory;
            }
            catch { }
            if (folderBrowserDialog1.ShowDialog() != DialogResult.OK)
                return;
            capTextBox.Text = capDirectory = folderBrowserDialog1.SelectedPath;
            commandLineBox.Text = getCommandLine();
        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {

        }
        #endregion
        #region Text and Combo Boxes
        private void textBox5_TextChanged(object sender, EventArgs e)
        {
            dumpFilterName = textBox5.Text;
            commandLineBox.Text = getCommandLine();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            capMins = int.Parse(comboBox1.Text);
            capTotalSecs = capMins * 60 + capSecs;
            textBox8.Text = capTotalSecs.ToString();
            commandLineBox.Text = getCommandLine();
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            capSecs = int.Parse(comboBox2.Text);
            capTotalSecs = capMins * 60 + capSecs;
            textBox8.Text = capTotalSecs.ToString();
            commandLineBox.Text = getCommandLine();
        }

        private void comboBox1_TextChanged(object sender, EventArgs e)
        {
            try
            {
                capMins = int.Parse(comboBox1.Text);
            }
            catch
            {
                capMins = 0;
            }
            capTotalSecs = capMins * 60 + capSecs;
            textBox8.Text = capTotalSecs.ToString();
            commandLineBox.Text = getCommandLine();
        }

        private void comboBox2_TextChanged(object sender, EventArgs e)
        {
            try
            {
                capSecs = int.Parse(comboBox2.Text);
            }
            catch
            {
                capSecs = 0;
            }
            capTotalSecs = capMins * 60 + capSecs;
            textBox8.Text = capTotalSecs.ToString();
            commandLineBox.Text = getCommandLine();
        }

        private void comboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            recordedFileName = comboBox3.Text;
            commandLineBox.Text = getCommandLine();

        }

        private void comboBox3_TextChanged(object sender, EventArgs e)
        {
            recordedFileName = comboBox3.Text;
            commandLineBox.Text = getCommandLine();
        }
        #endregion

        private void spIbutton_Click(object sender, EventArgs e)
        {
            StreamWriter sw;
            StreamReader sr;
            StreamReader err;

            Process p = new Process();
            ProcessStartInfo startInfo = new ProcessStartInfo("cmd");
            startInfo.WindowStyle = ProcessWindowStyle.Minimized;
            startInfo.WorkingDirectory = Path.GetDirectoryName(rcTVCapLocation);
            startInfo.UseShellExecute = false;
            startInfo.RedirectStandardOutput = true;
            startInfo.RedirectStandardInput = true;
            startInfo.RedirectStandardError = true;
            startInfo.CreateNoWindow = true;
//            p.PriorityClass = ProcessPriorityClass.High;
            p.StartInfo = startInfo;
            p.Start();

//            Process.Start(startInfo);
            sw = p.StandardInput;
            sr = p.StandardOutput;
            err = p.StandardError;
            Regex notAlpha = new Regex("\b");
            sw.AutoFlush = true;
            sw.WriteLine(commandString);
//            string input;
            /*
            while((input=sr.ReadLine()) != null)
            {
                commandLineBox.Text += notAlpha.Replace(input, "");
            }
            */
            sw.Close();
            //            Regex notAlpha = new Regex("[^a-zA-Z\t\r\n]");

//            string fixedString = notAlpha.Replace(startString, "");

            commandLineBox.Text = notAlpha.Replace(sr.ReadToEnd(),"");
//            commandLineBox.Text = sr.ReadToEnd();
            commandLineBox.Text += err.ReadToEnd();
        }

        private void saveConfigButton_Click(object sender, EventArgs e)
        {
            Configuration.Serialize(ConfigXMLFile, c);
        }

        private void CreateGraphButton_Click(object sender, EventArgs e)
        {
            IFilterGraph2 graphBuilderFile = (IFilterGraph2)new FilterGraph();
            IBaseFilter capture = DirectShowLib.Utils.FilterGraphTools.AddFilterByName(graphBuilderFile, FilterCategory.VideoInputDevice,"Hauppauge HD PVR Capture Device");
            IBaseFilter crossbar = DirectShowLib.Utils.FilterGraphTools.AddFilterByName(graphBuilderFile, FilterCategory.AMKSCrossbar, "Hauppauge HD PVR Crossbar");
            IBaseFilter encoder = DirectShowLib.Utils.FilterGraphTools.AddFilterByName(graphBuilderFile, FilterCategory.WDMStreamingMultiplexerDevices, "Hauppauge HD PVR Encoder");
            IBaseFilter dumpFile = DirectShowLib.Utils.FilterGraphTools.AddFilterByName(graphBuilderFile, FilterCategory.LegacyAmFilterCategory, "File Dump");
            //                                                                                                           {6CA646FD-CE11-417D-9888-A56C6BAC342C}
//            IBaseFilter dumpFile = (DirectShowLib.IBaseFilter)Activator.CreateInstance(Type.GetTypeFromCLSID(new DsGuid("{6CA646FD-CE11-417D-9888-A56C6BAC342C}")));
            bool success = DirectShowLib.Utils.FilterGraphTools.RenderPin(graphBuilderFile, crossbar, "0: Video Decoder Out");
            if (success) success = DirectShowLib.Utils.FilterGraphTools.RenderPin(graphBuilderFile, capture, "Virtual Video Out");
            if (success) success = DirectShowLib.Utils.FilterGraphTools.RenderPin(graphBuilderFile, crossbar, "1: Audio Decoder Out");
            if (success) success = DirectShowLib.Utils.FilterGraphTools.RenderPin(graphBuilderFile, capture, "Virtual Audio Out");
            if (success) DirectShowLib.Utils.FilterGraphTools.ConnectFilters(graphBuilderFile, encoder, "H.264 Out", dumpFile,"Input", false );            
            SaveGraphFile(graphBuilderFile, KLGraphFile); 
        }

// Lifted straight from FilterGraphTools.cs
//
        /// <summary>
        /// Save a DirectShow Graph to a GRF file
        /// </summary>
        /// <param name="graphBuilder">the IGraphBuilder interface of the graph</param>
        /// <param name="fileName">the file to be saved</param>
        /// <exception cref="System.ArgumentNullException">Thrown if graphBuilder is null</exception>
        /// <exception cref="System.Runtime.InteropServices.COMException">Thrown if errors occur during the file creation</exception>
        /// <seealso cref="LoadGraphFile"/>
        /// <remarks>This method overwrites any existing file</remarks>

        [SecurityPermission(SecurityAction.LinkDemand, UnmanagedCode = true)]
        public static void SaveGraphFile(IGraphBuilder graphBuilder, string fileName)
        {
            int hr = 0;
            IStorage storage = null;
            IStream stream = null;

            if (graphBuilder == null)
                throw new ArgumentNullException("graphBuilder");

            try
            {
                hr = NativeMethods.StgCreateDocfile(
                    fileName,
                    STGM.Create | STGM.Transacted | STGM.ReadWrite | STGM.ShareExclusive,
                    0,
                    out storage
                    );

                Marshal.ThrowExceptionForHR(hr);

                hr = storage.CreateStream(
                    @"ActiveMovieGraph",
                    STGM.Write | STGM.Create | STGM.ShareExclusive,
                    0,
                    0,
                    out stream
                    );

                Marshal.ThrowExceptionForHR(hr);

                hr = (graphBuilder as IPersistStream).Save(stream, true);
                Marshal.ThrowExceptionForHR(hr);

                hr = storage.Commit(STGC.Default);
                Marshal.ThrowExceptionForHR(hr);
            }
            finally
            {
                if (stream != null)
                    Marshal.ReleaseComObject(stream);
                if (storage != null)
                    Marshal.ReleaseComObject(storage);
            }
        }



        #region Hauppauge Encoder Property Page
        private void encoderButton_Click(object sender, EventArgs e)
        {
            IFilterGraph2 graphBuilderEnc = (IFilterGraph2)new FilterGraph();
            IBaseFilter filter = DirectShowLib.Utils.FilterGraphTools.AddFilterByName(graphBuilderEnc, FilterCategory.WDMStreamingMultiplexerDevices, "Hauppauge HD PVR Encoder");
//            IBaseFilter crossbar = DirectShowLib.Utils.FilterGraphTools.AddFilterByName(graphBuilderEnc, FilterCategory.AMKSCrossbar, "Hauppauge HD PVR Crossbar");
//            IBaseFilter capture = DirectShowLib.Utils.FilterGraphTools.AddFilterByName(graphBuilderEnc, FilterCategory.VideoInputDevice, "Hauppauge HD PVR Capture Device");
//            IBaseFilter demux = DirectShowLib.Utils.FilterGraphTools.AddFilterByName(graphBuilderEnc, FilterCategory.VideoInputDevice, "ArcSoft MPEG Demux");
//            IBaseFilter demux = (DirectShowLib.IBaseFilter)Activator.CreateInstance(Type.GetTypeFromCLSID(new DsGuid("{D5F9370B-E232-464F-BE29-A885B1249190}")));  //{D5F9370B-E232-464F-BE29-A885B1249190}
//            DisplayPropertyPage(filter);
            DisplayPropertyPage(filter);
        }
        private void DisplayPropertyPage(IBaseFilter dev)
        {
            //Get the ISpecifyPropertyPages for the filter
            ISpecifyPropertyPages pProp = dev as ISpecifyPropertyPages;
            int hr = 0;

            if (pProp == null)
            {
                //If the filter doesn't implement ISpecifyPropertyPages, try displaying IAMVfwCompressDialogs instead!
                IAMVfwCompressDialogs compressDialog = dev as IAMVfwCompressDialogs;
                if (compressDialog != null)
                {

                    hr = compressDialog.ShowDialog(VfwCompressDialogs.Config, IntPtr.Zero);
                    DsError.ThrowExceptionForHR(hr);
                }
                return;
            }

            //Get the name of the filter from the FilterInfo struct
            FilterInfo filterInfo;
            hr = dev.QueryFilterInfo(out filterInfo);
            DsError.ThrowExceptionForHR(hr);

            // Get the propertypages from the property bag
            DsCAUUID caGUID;
            hr = pProp.GetPages(out caGUID);
            DsError.ThrowExceptionForHR(hr);

            // Check for property pages on the output pin
            IPin pPin = DsFindPin.ByDirection(dev, PinDirection.Output, 0);
            ISpecifyPropertyPages pProp2 = pPin as ISpecifyPropertyPages;
            if (pProp2 != null)
            {
                DsCAUUID caGUID2;
                hr = pProp2.GetPages(out caGUID2);
                DsError.ThrowExceptionForHR(hr);

                if (caGUID2.cElems > 0)
                {
                    int soGuid = Marshal.SizeOf(typeof(Guid));

                    // Create a new buffer to hold all the GUIDs
                    IntPtr p1 = Marshal.AllocCoTaskMem((caGUID.cElems + caGUID2.cElems) * soGuid);

                    // Copy over the pages from the Filter
                    for (int x = 0; x < caGUID.cElems * soGuid; x++)
                    {
                        Marshal.WriteByte(p1, x, Marshal.ReadByte(caGUID.pElems, x));
                    }

                    // Add the pages from the pin
                    for (int x = 0; x < caGUID2.cElems * soGuid; x++)
                    {
                        Marshal.WriteByte(p1, x + (caGUID.cElems * soGuid), Marshal.ReadByte(caGUID2.pElems, x));
                    }

                    // Release the old memory
                    Marshal.FreeCoTaskMem(caGUID.pElems);
                    Marshal.FreeCoTaskMem(caGUID2.pElems);

                    // Reset caGUID to include both
                    caGUID.pElems = p1;
                    caGUID.cElems += caGUID2.cElems;
                }
            }

            // Create and display the OlePropertyFrame
            object oDevice = (object)dev;
            hr = OleCreatePropertyFrame(this.Handle, 0, 0, filterInfo.achName, 1, ref oDevice, caGUID.cElems, caGUID.pElems, 0, 0, IntPtr.Zero);
            DsError.ThrowExceptionForHR(hr);

            // Release COM objects
            Marshal.FreeCoTaskMem(caGUID.pElems);
            Marshal.ReleaseComObject(pProp);
            if (filterInfo.pGraph != null)
            {
                Marshal.ReleaseComObject(filterInfo.pGraph);
            }
        }
        #endregion

        private void CreateBatButton_Click(object sender, EventArgs e)
        {
            StringBuilder sb = new StringBuilder();
            if (CCCheckBox.Checked)
            {
                sb.AppendLine("\"" + CCFile + "\" " + CCParamTextBox.Text);
                sb.AppendLine("\"" + NodOff + "\" " + NodOffTime);
            }
            sb.AppendLine("cd /D " + "\"" + Path.GetDirectoryName(rcTVCapLocation)+"\"");
//            commandLineBox.Text = "cd /D " + "\"" + Path.GetDirectoryName(rcTVCapLocation) + "\"\r\n";
            string profile_param = "";
            if (ProfileCheckBox.Checked && ProfileText.Length != 0)
                profile_param = " " + "\"" + ProfileText + "\"";

            sb.AppendLine("\"" + rcTVCapLocation + "\" " + "\"" + graphFile + "\" " + "\"" + dumpFilterName +"\" "+ capTotalSecs + " \"" + Path.Combine(capDirectory, recordedFileName) + ".ts\"" + profile_param);
            string batfileName = Path.ChangeExtension(Path.Combine(capDirectory, recordedFileName), ".bat");
            if (DGCheckBox.Checked)
            {
                string KLSync = Path.ChangeExtension(Path.Combine(capDirectory, recordedFileName), ".ts");
                sb.AppendLine("KLSync " + KLSync);
                string DGAFile = Path.Combine(capDirectory, recordedFileName) + ".dga";
                sb.AppendLine("\"" + DGAVCFile + "\" " + "-i \"" + Path.Combine(capDirectory, recordedFileName) + ".264\" " + "-o \"" + Path.Combine(capDirectory, recordedFileName) + ".dga\"  -f 2 -e");
                if (AVSCheckBox.Checked)
                {
                    string AVSFileName = Path.Combine(capDirectory, recordedFileName) + "_" + Path.GetFileName(TemplatePath);
                    StreamReader avsreader = new StreamReader(TemplatePath);
                    Regex dgloc = new Regex("__DGLOCATION__");
                    Regex dgaFile = new Regex("__vid__");
                    Regex x264Loc = new Regex("__x264LOCATION");
                    Regex x264Output = new Regex("__OUTPUTMKV__");
                    Regex x264Input = new Regex("__INPUTAVS__");
                    FileStream avsfs = File.OpenWrite(AVSFileName);
                    TextWriter avswriter = new StreamWriter(avsfs);
                    Match dglocMatch;
                    Match dgaFileMatch;
                    Match x264LocMatch;
                    Match x264OutputMatch;
                    Match x264InputMatch;
                    string line;
                    while ((line = avsreader.ReadLine()) != null)
                    {
                        dglocMatch = dgloc.Match(line);
                        dgaFileMatch = dgaFile.Match(line);
                        if (dglocMatch.Length != 0)
                        {
                            line = Regex.Replace(line, "__DGLOCATION__", Path.GetDirectoryName(DGAVCFile));
                        }
                        if (dgaFileMatch.Length != 0)
                        {
                            line = Regex.Replace(line, "__vid__", DGAFile);
                        }
                        avswriter.WriteLine(line);
                    }
                    avsreader.Close();
                    avswriter.Close();
                    avsfs.Close();
                    StreamReader x264reader = new StreamReader(x264TemplatePath);
                    while ((line = x264reader.ReadLine()) != null)
                    {
                        x264LocMatch = x264Loc.Match(line);
                        x264OutputMatch = x264Output.Match(line);
                        x264InputMatch = x264Input.Match(line);
                        if (x264LocMatch.Length != 0)
                        {
                            line = Regex.Replace(line, "__x264LOCATION__", x264Path);
                        }
                        if (x264OutputMatch.Length != 0)
                        {
                            string mkv = Path.ChangeExtension(AVSFileName, ".mkv");
                            line = Regex.Replace(line, "__OUTPUTMKV__", Path.Combine(Path.GetDirectoryName(AVSFileName), mkv));
                        }
                        if (x264InputMatch.Length != 0)
                        {
                            //                            string mkv = Path.ChangeExtension(AVSFileName,".mkv");
                            line = Regex.Replace(line, "__INPUTAVS__", AVSFileName);
                        }
                        sb.AppendLine(line);
                    }
                    x264reader.Close();
                }
            }
            commandLineBox.Text = sb.ToString();
            commandLineBox.Text += "Writing Batch File Name: " + batfileName + "\r\n";
            FileStream fs = File.OpenWrite(batfileName);
            TextWriter writer = new StreamWriter(fs);
            writer.Write(sb.ToString());
            writer.Close();
            fs.Close();
            if (StartNowCheckBox.Checked)
                Process.Start(batfileName);
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            Configuration.Serialize(ConfigXMLFile, c);
        }

        private void NodOffButton_Click_1(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = Path.GetDirectoryName(NodOff);
            openFileDialog1.Filter = "Nod Off(*.exe)|*.exe";
            if (openFileDialog1.ShowDialog() != DialogResult.OK)
                return;
            NodOffTextBox.Text = NodOff = openFileDialog1.FileName;
            commandLineBox.Text = getCommandLine();

        }

        private void NodOffTimeTextBox_TextChanged(object sender, EventArgs e)
        {
            NodOffTime = NodOffTimeTextBox.Text;
            commandLineBox.Text = getCommandLine();

        }

        private void ProfileCheckBox_CheckedChanged(object sender, EventArgs e)
        {
            if (!ProfileCheckBox.Checked)
            {
                ProfileListBox.Enabled = false;
                EditProfButton.Enabled = false;
                commandLineBox.Text = getCommandLine();
                return;
            }
            else
            {
                EditProfButton.Visible = true;
                EditProfButton.Enabled = true;
                ProfileListBox.Enabled = true;
            }
            commandLineBox.Text = getCommandLine();
            if (ProfilesLoaded)
                return;
            ProfilesLoaded = true;
//            FilterProfiles fp = new FilterProfiles();
            string XMLFullName = Path.Combine(Path.GetDirectoryName(rcTVCapLocation),"FilterProfiles.xml");
            if (!File.Exists(XMLFullName))
            {
                throw new System.Exception("Could not find filter profiles file: " + XMLFullName);
            }
            fp = (FilterProfiles)FilterProfiles.LoadFromFileFast(fp.GetType(), XMLFullName);
            bool foundProfile = false;
            string[] BModes = { "Constant", "Variable", "Variable Peak" };
            foreach (FilterProfiles.Profile p in fp.Profiles)
            {
//                if (p.Name.ToUpper() == FilterProfiles.PropfileName.ToUpper())
//                {
                    foundProfile = true;
                    /*
                    wc("Applying filter properties for profile name: " + ProfileName);
                    wc("Profile Comment: " + p.Comment);
                    wc("~~~~~~~~~~~~~~~~~~~~~~~~~~");
                    */
                    ProfileListBox.Items.Add(p.Name); 
                                        
                    commandLineBox.Text += "\r\n" + p.Name + "\r\n";
                    foreach (FilterProfiles.Profile.PropSet ps in p.FilterProps)
                    {
                        //now apply each filter property
                        if (ps.Comment == "Bitrate Mode")
                            commandLineBox.Text += ps.Comment + ":" + BModes[ps.Value] + "\r\n";
                        else
                           commandLineBox.Text += ps.Comment + ":" + ps.Value + "\r\n";
                    }
            }

        }

        private void ProfileListBox_SelectedIndexChanged_1(object sender, EventArgs e)
        {
            ProfileText = ProfileListBox.Text;
            int yy = ProfileListBox.SelectedIndex; 
            commandLineBox.Text = getCommandLine();
            FilterProfiles.Profile p = fp.Profiles[yy];
            commandLineBox.Text += "\r\n";
            foreach (FilterProfiles.Profile.PropSet ps in p.FilterProps)
            {
                    commandLineBox.Text += ps.Comment + ":" + ps.Value + "\r\n";
//                        double tmp1 = Convert.ToDouble(ps.Value) / 1000000.0;
//                        AvgBRBox.Text = tmp1.ToString("N1");
//                        AvgBRBox.Text = ps.Value.ToString();
            }            
        }

        // Event handler for EditProfButton, originally named button3, I'm lazy :)
        private void button3_Click(object sender, EventArgs e)
        {
            dirt.dirt = 0;
            EditProfForm epf = new EditProfForm();
            epf.MyParentForm = this;
            epf.fp = fp;
            epf.dirt = dirt;
            epf.XMLFullName = XMLFullName;
            epf.ShowDialog();
            if (dirt.dirt > 0)
            {
                ProfileListBox.Items.Clear();  // clear it out so we can reload with the new values
                foreach (FilterProfiles.Profile p in fp.Profiles)
                    ProfileListBox.Items.Add(p.Name);
                // Profile was added, need to update the ProfComboBox selections
            }
        }


/*
        private void CCParamTextBox_TextChanged(object sender, EventArgs e)
        {
            CCParam = CCParamTextBox.Text;
            commandLineBox.Text = getCommandLine();

        }
*/
    }
}
